require_relative 'tcp.rb'
require_relative 'http_response.rb'
require_relative 'http_get_request.rb'
require_relative 'http_post_request.rb'
require_relative 'http_head_request.rb'

module Nastika

# Implements the HTTP functionality
class HTTP
  attr_accessor :host
  attr_accessor :port
  attr_accessor :response
  attr_accessor :request

  # Initialized the HTTP object
  # Params:
  # +host+:: Host to connect to 
  # +port+:: port to connect to
  # +request+:: request object to send
  def initialize(host=nil, port=nil, request=nil)
      self.host = host
      self.port = port
      self.request = request.to_s
  end
  
  # Sends the request and gets the response
  def get_repsonse
    response = Nastika::HTTP::Response.new(make_request)
  end

  # Makes the request.
  def make_request
    tcp = Nastika::TCP.new(self.host, self.port)
    tcp.payload = self.request
    
    begin
      tcp.connect
      tcp.send
    rescue => exception
      raise exception
    ensure
      tcp.close
    end
  end
  
end

end
