module Nastika
  # This response class is responsible for
  # parsing reponses from the server. Right now
  # the implementation is very bad.
  # TODO: Fix implementation ASAP.
  class HTTP
    class Response
      attr_accessor :code
      attr_accessor :body
      attr_accessor :headers
      attr_accessor :httpver
      attr_accessor :status

      # Takes in a response string and parses it to give
      # response code, body, http version, status and headers.
      def initialize(response)
        # HTTP REQ LOOKS LIKE THIS:
        # HTTP/HTTPVER CODE STATUS
        # HEADERS FOLLOWED BY CRLF
        # CRLF
        # OPTIONAL_BODY
        if response.include? "\r\n"
          response = response.split "\r\n"
        else
          response = response.split "\n"
        end
        self.httpver = response[0].split(" ")[0].split("/")[1]
        self.code = response[0].split(" ")[1]
        self.status = response[0].split(" ")[2]
        self.headers = {}

        response.each_with_index do |a, i|
          if a == ""
            self.body = response[i+1]
            break
          end
          next unless a.include? ":"
          self.headers[a.split(":")[0].strip] = a.split(":")[1].strip
        end
        
      end
    end
  end
end
